#ifndef lint
static const char Rcs_Id[] =
    "$Id: fieldtest.cc,v 1.1 1996/02/14 19:16:38 geoff Exp $";
#endif

/*
 * $Log: fieldtest.cc,v $
 * Revision 1.1  1996/02/14 19:16:38  geoff
 * Initial revision
 *;
 */

#include <fstream.h>
#include <stdlib.h>
#include "fields.hh"

int main (
    int			argc,
    char*		argv[])
    {
    if (argc != 4)
	{
	cerr << "Usage:  fieldtest delims flags maxf\n";
	cerr << "\tFlag bits:\n";
	cerr << "\tRUNS\t" << ParsedFields::RUNS << '\n';
	cerr << "\tSINGLE_QUOTES\t" << ParsedFields::SINGLE_QUOTES << '\n';
	cerr << "\tBACK_QUOTES\t" << ParsedFields::BACK_QUOTES << '\n';
	cerr << "\tDOUBLE_QUOTES\t" << ParsedFields::DOUBLE_QUOTES << '\n';
	cerr << "\tSHELL_QUOTES\t" << ParsedFields::SHELL_QUOTES << '\n';
	cerr << "\tSTRIP_QUOTES\t" << ParsedFields::STRIP_QUOTES << '\n';
	cerr << "\tBACKSLASH\t" << ParsedFields::BACKSLASH << '\n';
	return 1;
	}
    ParsedFields* fields1;
    while ((fields1 =
	new ParsedFields(cin, argv[1], atoi (argv[2]), atoi (argv[3])))
      &&  *fields1)
	{
	cout << "" << fields1->count() << ':';
	fields1->write(cout, '@');
	}
    delete fields1;
    ParsedFields fields("This:is:a:simple:test\n", ":");
    cout << fields.count() << ':';
    fields.write(cout, ' ');
    ParsedFields* fields2 =
      new ParsedFields("This:is:another::test\n", ":", ParsedFields::RUNS, 0);
    cout << fields2->count() << ':';
    fields2->write(cout, ' ');
    delete fields2;
    ParsedFields fields3("a1 b2 c3");
    cout << "a1=" << fields3[0] << ", b2=" << fields3[1] << ", c3="
      << fields3[2] << '\n';
    ParsedFields fields4("\\1411", " ", ParsedFields::BACKSLASH);
    cout << "a1=";
    fields4.write(cout, '!');
    cout << '\n';
    return 0;
    }
