/*
 * $Id: list.h,v 1.3 1997/02/03 23:47:57 geoff Exp $
 *
 * $Log: list.h,v $
 * Revision 1.3  1997/02/03 23:47:57  geoff
 * Improvements from two years ago: add joinlists.
 *
 * Revision 1.2  1994/02/15  21:39:26  geoff
 * Move OFFSETOF and RECBASE to list.h.
 *
 * Revision 1.1  1994/01/04  20:18:49  geoff
 * Initial revision
 *
 */

#undef P
#undef VOID
#ifdef __STDC__
#define P(x)	x
#define VOID	void
#else /* __STDC__ */
#define P(x)	()
#define VOID	char
#endif /* __STDC__ */

/*
 * Generalized double list link.  Anything that can link on a list
 * must start with a "next" and a "prev" field, just like this structure.
 * This structure can also be used for the head of a list, if desired.
 */
typedef struct link
    {
    struct link *	next;		/* Next item on list */
    struct link *	prev;		/* Previous item on list */
    }
			link_t;

extern void		initlist P ((link_t * head));
extern void		inslist P ((link_t * where, link_t * item));
extern void		remlist P ((link_t * item));
extern void		appendlist P ((link_t * where, link_t * head));
extern void		joinlists P ((link_t * where, link_t * other));

/*
 * Macro for finding the offset of a field in a structure.  Stolen
 * from X11.h, more or less.  Doesn't work on Crays (see X11.h if you care).
 */
#ifdef offsetof
#define OFFSETOF(t, f) offsetof(t, f)
#else
#define OFFSETOF(t, f) \
	((unsigned long) (((char *) (&(((t *) NULL)->f))) - ((char *) NULL)))
#endif

/*
 * Handy macro for finding the beginning of a record based on a
 * pointer to one of its list links.
 */
#define RECBASE(p, t, f) \
		((t *) ((char *) (p) - OFFSETOF (t, f)))
