#ifndef lint
static char Rcs_Id[] =
    "$Id: strerr.c,v 1.4 1999/11/17 07:20:40 geoff Exp $";
#endif

/*
 * $Log: strerr.c,v $
 * Revision 1.4  1999/11/17 07:20:40  geoff
 * Add more constness
 *
 * Revision 1.3  1998/01/31 06:32:38  geoff
 * Fix the declaration of strerr to match current header files
 *
 * Revision 1.2  1997/07/16  22:22:34  geoff
 * Declare sys_errlist as const when possible.
 *
 * Revision 1.1  1994/02/17  18:24:09  geoff
 * Initial revision
 *
 */

#include <errno.h>
#include <stdio.h>

#undef P
#undef VOID
#ifdef __STDC__
#define P(x)	x
#define VOID	void
#else /* __STDC__ */
#define P(x)	()
#define VOID	char
#endif /* __STDC__ */

#ifdef __STDC__
const
#endif /* __STDC__ */
char *		strerr P ((int errnum));

#define MAX_DECIMAL_WIDTH \
		(sizeof (int) == 4 ? 11 \
		  : sizeof (int) == 8 ? 21 \
		  : (sizeof (int) * 3))

#if defined(_ANSI_SOURCE)  ||  defined(_POSIX_SOURCE)
#ifdef __STDC__
extern const char *const sys_errlist[];
#else /* __STDC__ */
extern char *	sys_errlist[];
#endif /* __STDC__ */
#else /* _ANSI_SOURCE || _POSIX_SOURCE */
extern char *	sys_errlist[];
#endif /* _ANSI_SOURCE || _POSIX_SOURCE */
extern int	sys_nerr;

#ifdef __STDC__
const
#endif /* __STDC__ */
char * strerr (errnum)
    int			errnum;	/* Error number to report on, or 0 for errno */
    {
    static char		errbuf[sizeof "unknown error " + MAX_DECIMAL_WIDTH];

    if (errnum == 0)
	errnum = errno;
    if (errnum <= 0  ||  errnum >= sys_nerr)
	{
	(void) sprintf (errbuf, "unknown error %d", errnum);
	return errbuf;
	}
    else
	return sys_errlist[errnum];
    }
