#ifndef _BASICTYPES_HH
#define _BASICTYPES_HH
/*
 * $Id: basictypes.hh,v 1.4 1996/05/03 01:11:26 geoff Exp $
 *
 * UCLA Ficus Project
 *
 * Copyright (c) 1995, 1996 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * $Log: basictypes.hh,v $
 * Revision 1.4  1996/05/03 01:11:26  geoff
 * Update the copyright.
 *
 * Revision 1.3  1995/12/19  00:34:04  geoff
 * Add a definition of NULL, if needed.
 *
 * Revision 1.2  1995/11/22  00:19:33  geoff
 * Get rid of the NEW_FILE_RELATIONS ifdef.
 *
 * Revision 1.1  1995/11/10  02:09:40  geoff
 * Initial revision
 *
 */

/*
 * This file contains declarations of types and macros that are so
 * basic that nearly everything is derived from or uses them.
 */

#ifndef NUMOF
#define NUMOF(x)	(sizeof(x) / sizeof(x[0]))
#endif // NUMOF

#ifndef NULL
#define NULL		0
#endif // NULL

/*
 * Type used to hold a count of the number of references to a file.
 * This is used by a lot of files we include, so we need to define it here
 */
typedef unsigned long	ReferenceCount;

#endif // _BASICTYPES_HH
