#ifndef _SHOWOPTIONS_HH
#define _SHOWOPTIONS_HH
/*
 * $Id: showoptions.hh,v 1.5 1998/05/14 01:15:40 geoff Exp $
 *
 * UCLA Ficus Project
 *
 * Copyright (c) 1995, 1996 The Regents of the University of California.
 * All rights reserved.
 *
 * Redistribution and use in source and binary forms, with or without
 * modification, are permitted provided that the following conditions
 * are met:
 * 1. Redistributions of source code must retain the above copyright
 *    notice, this list of conditions and the following disclaimer.
 * 2. Redistributions in binary form must reproduce the above copyright
 *    notice, this list of conditions and the following disclaimer in the
 *    documentation and/or other materials provided with the distribution.
 * 3. All advertising materials mentioning features or use of this software
 *    must display the following acknowledgement:
 *      This product includes software developed by the University of
 *      California, Los Angeles and its contributors.
 * 4. Neither the name of the University nor the names of its contributors
 *    may be used to endorse or promote products derived from this software
 *    without specific prior written permission.
 *
 * THIS SOFTWARE IS PROVIDED BY THE REGENTS AND CONTRIBUTORS ``AS IS'' AND
 * ANY EXPRESS OR IMPLIED WARRANTIES, INCLUDING, BUT NOT LIMITED TO, THE
 * IMPLIED WARRANTIES OF MERCHANTABILITY AND FITNESS FOR A PARTICULAR PURPOSE
 * ARE DISCLAIMED.  IN NO EVENT SHALL THE REGENTS OR CONTRIBUTORS BE LIABLE
 * FOR ANY DIRECT, INDIRECT, INCIDENTAL, SPECIAL, EXEMPLARY, OR CONSEQUENTIAL
 * DAMAGES (INCLUDING, BUT NOT LIMITED TO, PROCUREMENT OF SUBSTITUTE GOODS
 * OR SERVICES; LOSS OF USE, DATA, OR PROFITS; OR BUSINESS INTERRUPTION)
 * HOWEVER CAUSED AND ON ANY THEORY OF LIABILITY, WHETHER IN CONTRACT, STRICT
 * LIABILITY, OR TORT (INCLUDING NEGLIGENCE OR OTHERWISE) ARISING IN ANY WAY
 * OUT OF THE USE OF THIS SOFTWARE, EVEN IF ADVISED OF THE POSSIBILITY OF
 * SUCH DAMAGE.
 */

/*
 * $Log: showoptions.hh,v $
 * Revision 1.5  1998/05/14 01:15:40  geoff
 * Add MIME-encoding support.
 *
 * Revision 1.4  1996/05/03 01:13:05  geoff
 * Update the copyright.
 *
 * Revision 1.3  1995/11/22  00:22:24  geoff
 * Fix the RCS comment leader.
 *
 * Revision 1.2  1995/08/07  20:03:15  geoff
 * Add SO_EMPTY_CLUSTERS.
 *
 * Revision 1.1  1995/06/30  18:35:20  geoff
 * Initial revision
 *
 */

/*
 * This header file defines options that can be passed to show
 * (output) routines to control what is shown.  The options are a bit
 * mask.
 */
typedef unsigned int	ShowOptions;

const unsigned int	SO_NONE = 0x0000;
					// No special options
const unsigned int	SO_ALL_MANAGERS = 0x0001;
					// Show data for all managers
const unsigned int	SO_MANAGER = 0x0002;
					// Show data for one manager, named
					// ..in a separate argument
const unsigned int	SO_FULL_FILE_INFORMATION = 0x0004;
					// Show full information (not just ID)
					// ..for any files displayed by show
					// ..routine
const unsigned int	SO_EMPTY_CLUSTERS = 0x0008;
					// Show headers for empty clusters
const unsigned int	SO_MIME_ENCODE = 0x0010;
					// MIME-encode filename strings
const unsigned int	SO_EVERYTHING = ~SO_MIME_ENCODE;
					// Show everything possible

#endif // _SHOWOPTIONS_HH
